export interface List<T, C> extends Iterable<T> {
    item: T | null;
    next: List<T, C> | null;
    context: C;
    toArray(): Array<T>;
}
export declare function atEnd<T, C>(xs: List<T, C>): xs is (List<T, C> & {
    item: null;
    next: null;
});
export declare function notAtEnd<T, C>(xs: List<T, C>): xs is (List<T, C> & {
    item: T;
    next: List<T, C>;
});
export declare class ArrayList<T, C> implements List<T, C> {
    context: C;
    readonly items: Array<T>;
    readonly index: number;
    constructor(items: Array<T>, context: C, index?: number);
    get item(): T | null;
    get next(): List<T, C> | null;
    toArray(): Array<T>;
    [Symbol.iterator](): Iterator<T>;
}
