/// SPDX-License-Identifier: GPL-3.0-or-later
/// SPDX-FileCopyrightText: Copyright © 2016-2025 Tony Garnock-Jones <tonyg@leastfixedpoint.com>
export function atEnd(xs) {
    return xs.item === null;
}
export function notAtEnd(xs) {
    return xs.item !== null;
}
export class ArrayList {
    constructor(items, context, index = 0) {
        this.context = context;
        this.index = 0;
        this.items = items;
        this.index = index;
    }
    get item() {
        var _a;
        return (_a = this.items[this.index]) !== null && _a !== void 0 ? _a : null;
    }
    get next() {
        if (this.index >= this.items.length)
            return null;
        return new ArrayList(this.items, this.context, this.index + 1);
    }
    toArray() {
        return this.items.slice(this.index);
    }
    [Symbol.iterator]() {
        let i = this;
        return {
            next() {
                if (notAtEnd(i)) {
                    const value = i.item;
                    i = i.next;
                    return { done: false, value };
                }
                else {
                    return { done: true, value: null };
                }
            }
        };
    }
}
//# sourceMappingURL=list.js.map