/// SPDX-License-Identifier: GPL-3.0-or-later
/// SPDX-FileCopyrightText: Copyright © 2016-2025 Tony Garnock-Jones <tonyg@leastfixedpoint.com>
export function formatPos(p) {
    var _a;
    return p ? `${(_a = p.name) !== null && _a !== void 0 ? _a : '?'}:${p.line}:${p.column}` : '?';
}
export function startPos(name) {
    return { line: 1, column: 0, pos: 0, name };
}
export function fixPos(p) {
    return Object.assign(Object.assign({}, p), { fixed: true });
}
export function advancePos(p, ch) {
    var _a;
    if ((_a = p.fixed) !== null && _a !== void 0 ? _a : false) {
        return ch === '\n';
    }
    else {
        let advancedLine = false;
        p.pos++;
        switch (ch) {
            case '\t':
                p.column = (p.column + 8) & ~7;
                break;
            case '\n':
                p.column = 0;
                p.line++;
                advancedLine = true;
                break;
            case '\r':
                p.column = 0;
                break;
            default:
                p.column++;
                break;
        }
        return advancedLine;
    }
}
//# sourceMappingURL=position.js.map