export declare class SpanResult<T> {
    readonly searchTarget: number;
    readonly start: number;
    readonly items: Array<{
        end: number;
        item: T;
    }>;
    constructor(searchTarget: number, start: number);
    get offset(): number;
    get firstItem(): T;
    get lastItem(): T;
}
export declare class SpanIndex<T> {
    readonly index: Array<[number, Array<[number, T]>]>;
    get(pos: number): SpanResult<T> | null;
}
export declare class SpanInfo<T> {
    readonly spans: Map<number, Array<[number, T]>>;
    add(start: number, end: number, t: T): void;
    index(): SpanIndex<T>;
}
