/// SPDX-License-Identifier: GPL-3.0-or-later
/// SPDX-FileCopyrightText: Copyright © 2016-2025 Tony Garnock-Jones <tonyg@leastfixedpoint.com>

import { defineConfig, type Options } from 'tsup';

function options(prefix: string, minify: boolean): Options {
    return {
        entry: {
            [prefix]: 'src/index.ts',
        },
        format: ['cjs', 'esm', 'iife'],
        outExtension({ format }) {
            switch (format) {
                case 'cjs': return { js: '.cjs' };
                case 'esm': return { js: '.mjs' };
                case 'iife': return { js: '.js' };
            }
        },
        globalName: 'SyndicateCompiler',
        sourcemap: true,
        clean: true,
        minify,
        target: 'es2017',
    };
}

export default defineConfig([options('syndicate-compiler', false), options('syndicate-compiler.min', true)]);
